<?php
/**
 * WebshopApiTest
 * PHP version 7.2
 *
 * @category Class
 * @package  Teambank\RatenkaufByEasyCreditApiV3
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Ratenkauf Verkauf-V3 API Definition
 *
 * Ratenkauf Verkauf-V3 API for ratenkauf App
 *
 * The version of the OpenAPI document: V3.68.3
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 5.2.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Please update the test case below to test the endpoint.
 */

namespace Teambank\RatenkaufByEasyCreditApiV3\Test\Api;

use \Teambank\RatenkaufByEasyCreditApiV3\Configuration;
use \Teambank\RatenkaufByEasyCreditApiV3\ApiException;
use \Teambank\RatenkaufByEasyCreditApiV3\ObjectSerializer;
use PHPUnit\Framework\TestCase;

/**
 * WebshopApiTest Class Doc Comment
 *
 * @category Class
 * @package  Teambank\RatenkaufByEasyCreditApiV3
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class WebshopApiTest extends TestCase
{

    /**
     * Setup before running any test cases
     */
    public static function setUpBeforeClass(): void
    {
    }

    /**
     * Setup before running each test case
     */
    public function setUp(): void
    {
        $config = \Teambank\RatenkaufByEasyCreditApiV3\Configuration::getDefaultConfiguration()
            ->setHost('https://ratenkauf.easycredit.de')
            ->setUsername($_ENV['EASYCREDIT_USER'])
            ->setPassword($_ENV['EASYCREDIT_PASSWORD']);

        $this->apiInstance = new \Teambank\RatenkaufByEasyCreditApiV3\Service\WebshopApi(
            new \Teambank\RatenkaufByEasyCreditApiV3\Client(['debug'=>false]),
            $config
        );
    }

    /**
     * Clean up after running each test case
     */
    public function tearDown(): void
    {
    }

    /**
     * Clean up after running all test cases
     */
    public static function tearDownAfterClass(): void
    {
    }

    /**
     * Test case for apiPaymentV3WebshopGet
     *
     * Get the necessary information about the webshop.
     *
     */
    public function testApiPaymentV3WebshopGet() {

        list ($response, $statusCode) = $this->apiInstance->apiPaymentV3WebshopGetWithHttpInfo();

        $this->assertSame(200, $statusCode);
    }

    /**
     * Test case for apiPaymentV3WebshopIntegrationcheckPost
     *
     * Verifies the correctness of the merchant's authentication credentials and, if enabled, the body signature.
     *
     */
    public function testApiPaymentV3WebshopIntegrationcheckPost()
    {
        list ($response, $statusCode) = $this->apiInstance->apiPaymentV3WebshopIntegrationcheckPostWithHttpInfo(new \Teambank\RatenkaufByEasyCreditApiV3\Model\IntegrationCheckRequest([
            'message' => ''
        ]));

       $this->assertSame(200, $statusCode);
    }

    public function testApiPaymentV3WebshopIntegrationcheckPostWrongCredentials() {
        $config = \Teambank\RatenkaufByEasyCreditApiV3\Configuration::getDefaultConfiguration()
            ->setHost('https://ratenkauf.easycredit.de')
            ->setUsername($_ENV['EASYCREDIT_USER'])
            ->setPassword('wrong-password');

        $this->apiInstance = new \Teambank\RatenkaufByEasyCreditApiV3\Service\WebshopApi(
            new \Teambank\RatenkaufByEasyCreditApiV3\Client(['debug'=>false]),
            $config
        );

        $this->expectException(\Teambank\RatenkaufByEasyCreditApiV3\ApiException::class);
        $this->expectExceptionMessage('Bad credentials');

        list ($response, $statusCode) = $this->apiInstance->apiPaymentV3WebshopIntegrationcheckPostWithHttpInfo(new \Teambank\RatenkaufByEasyCreditApiV3\Model\IntegrationCheckRequest([
            'message' => ''
        ]));
    }
}
